This patch from Sami Farin lets you specify --fsync if you want fsync()
to be called on every file we write.

--- options.c	6 May 2004 21:08:01 -0000	1.148
+++ options.c	15 May 2004 20:20:27 -0000
@@ -37,6 +37,7 @@ int make_backups = 0;
  **/
 int whole_file = -1;
 
+int do_fsync = 0;
 int archive_mode = 0;
 int copy_links = 0;
 int preserve_links = 0;
@@ -230,6 +231,7 @@ void usage(enum logcode F)
   rprintf(F," -b, --backup                make backups (see --suffix & --backup-dir)\n");
   rprintf(F,"     --backup-dir            make backups into this directory\n");
   rprintf(F,"     --suffix=SUFFIX         backup suffix (default %s w/o --backup-dir)\n",BACKUP_SUFFIX);
+  rprintf(F,"     --fsync                 fsync every written file\n");
   rprintf(F," -u, --update                update only (don't overwrite newer files)\n");
   rprintf(F," -l, --links                 copy symlinks as symlinks\n");
   rprintf(F," -L, --copy-links            copy the referent of all symlinks\n");
@@ -332,6 +334,7 @@ static struct poptOption long_options[] 
   {"safe-links",       0,  POPT_ARG_NONE,   &safe_symlinks, 0, 0, 0 },
   {"help",            'h', POPT_ARG_NONE,   0,              'h', 0, 0 },
   {"backup",          'b', POPT_ARG_NONE,   &make_backups, 0, 0, 0 },
+  {"fsync",            0,  POPT_ARG_NONE,   &do_fsync, 0, 0, 0 },
   {"dry-run",         'n', POPT_ARG_NONE,   &dry_run, 0, 0, 0 },
   {"sparse",          'S', POPT_ARG_NONE,   &sparse_files, 0, 0, 0 },
   {"cvs-exclude",     'C', POPT_ARG_NONE,   &cvs_exclude, 0, 0, 0 },
@@ -943,6 +946,9 @@ void server_options(char **args,int *arg
 		args[ac++] = "--temp-dir";
 		args[ac++] = tmpdir;
 	}
+
+	if (do_fsync && am_sender)
+		args[ac++] = "--fsync";
 
 	if (compare_dest && am_sender) {
 		/* the server only needs this option if it is not the sender,
--- receiver.c	15 May 2004 19:31:10 -0000	1.78
+++ receiver.c	15 May 2004 20:20:27 -0000
@@ -46,6 +46,7 @@ extern int module_id;
 extern int ignore_errors;
 extern int orig_umask;
 extern int keep_partial;
+extern int do_fsync;
 
 static void delete_one(char *fn, int is_dir)
 {
@@ -266,6 +267,12 @@ static int receive_data(int f_in,struct 
 
 	if (fd != -1 && offset > 0 && sparse_end(fd) != 0) {
 		rsyserr(FERROR, errno, "write failed on %s",
+			full_fname(fname));
+		exit_cleanup(RERR_FILEIO);
+	}
+
+	if (do_fsync && (fd != -1) && (fsync(fd) != 0)) {
+		rsyserr(FERROR, errno, "fsync failed on %s",
 			full_fname(fname));
 		exit_cleanup(RERR_FILEIO);
 	}
--- util.c	15 May 2004 19:31:10 -0000	1.143
+++ util.c	15 May 2004 20:20:28 -0000
@@ -29,6 +29,7 @@
 
 extern int verbose;
 extern struct exclude_list_struct server_exclude_list;
+extern int do_fsync;
 
 int sanitize_paths = 0;
 
@@ -291,6 +292,12 @@ int copy_file(char *source, char *dest, 
 
 	if (close(ofd) < 0) {
 		rsyserr(FERROR, errno, "close failed on %s",
+			full_fname(dest));
+		return -1;
+	}
+
+	if (do_fsync && fsync(ofd) < 0) {
+		rsyserr(FERROR, errno, "fsync failed on %s",
 			full_fname(dest));
 		return -1;
 	}
